//********************************************************************
//*** ResourcePool/mysql/SQLSelectRow.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLSelectRow.hh,v 1.6 2005/01/09 13:50:17 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */


#ifndef RESOURCEPOOL_MYSQL_SQLSELECTROW_HH
#define RESOURCEPOOL_MYSQL_SQLSELECTROW_HH

#ifndef RESOURCEPOOL_MYSQL_SQLSELECT_HH
#include "SQLSelect.hh"
#endif

namespace fatalmind {
namespace mysql {

/**
 * A command to select exactly one row from an mysql database.
 */
class SQLSelectRow: public SQLSelect {
	public:
		SQLSelectRow(const std::string& SQL);
		void execute(MYSQL& dbh);
		virtual bool process();
	private:
		int _row;
};

}
}
#endif
