typedef fatalmind::ResourcePool<fatalmind::ResourceType::mysql> RP;

std::string getConnectString() {
	return std::string(getenv("FATALMIND_RESOURCEPOOL_MYSQL"));
}

RP::Factory getFactory() {
	return RP::Factory(getConnectString());
}

void init(RP& p) {
	RP::Command::SQLExecute sql(
		"create table hirsch (id numeric not null primary key, ukn varchar(255))"
	);
	p.execute(sql);
}

void clear(RP& p) {
	RP::Command::SQLExecute sql("delete from hirsch");
	p.execute(sql);
}

void drop(RP& p) {
	try {
		RP::Command::SQLExecute sql("drop table hirsch");
		p.execute(sql);
	} catch (...) {
	}
}

